version: '3.8'
services:
  itex-api:
    build: .
    container_name: itex-api
    ports:
      - "8080:8080"
    depends_on:
      mysqldb:
        condition: service_healthy
      keycloak:
        condition: service_started
      flyway:
        condition: service_started
    environment:
      - SPRING_PROFILES_ACTIVE=docker
      - KEYCLOAK_REALM_USERNAME=admin
      - KEYCLOAK_REALM_PASSWORD=admin
      - keycloak.auth-server-url=http://keycloak:9000
    networks:
      - itex-network
    healthcheck:
      test: "curl --fail --silent localhost:8080/actuator/health | grep UP || exit 1"
      timeout: 20s
      retries: 10
  mysqldb:
    image: mysql:8.0.28
    container_name: mysql
    restart: always
    ports:
      - "3306:3306"
    environment:
      MYSQL_DATABASE: itex
      MYSQL_ROOT_PASSWORD: password
    healthcheck:
      test: [ "CMD", "mysqladmin" ,"ping", "-h", "localhost" ]
      timeout: 20s
      retries: 10
    networks:
      - itex-network
  flyway:
    container_name: flyway
    image: flyway/flyway:6.3.1
    command: -connectRetries=60 -schemas=itex migrate
    environment:
      - FLYWAY_USER=root
      - FLYWAY_PASSWORD=password
      - FLYWAY_URL=jdbc:mysql://mysqldb:3306/itex?createDatabaseIfNotExist=true
      - FLYWAY_SCHEMAS=itex
      - FLYWAY_LOCATION=classpath:db/migration
      - FLYWAY_BASELINE_ON_MIGRATE=true
    depends_on:
      mysqldb:
        condition: service_healthy
    volumes:
      - ./src/main/resources/db/migration:/flyway/sql
    networks:
      - itex-network
  keycloak:
    container_name: keycloak
    image: quay.io/keycloak/keycloak:19.0.1
    entrypoint: '/opt/keycloak/bin/kc.sh start-dev --import-realm'
    ports:
      - "9000:9000"
    environment:
      KEYCLOAK_ADMIN: admin
      KEYCLOAK_ADMIN_PASSWORD: admin
      KC_HTTP_PORT: 9000
    volumes:
      - ./src/main/resources/keycloak-realm/realm-keycloak.json:/opt/keycloak/data/import/realm-keycloak.json:ro
    networks:
      - itex-network
#  vault:
#    container_name: vault
#    image: vault
#    environment:
#      VAULT_DEV_ROOT_TOKEN_ID: dev-only-token
#    ports:
#      - "8200:8200"
#    networks:
#      - itex-network
# TODO future version with secured passwords
networks:
  itex-network:
    name: itex-network